//: c13:AlwaysEven.java
// Demonstrating thread collision over resources by
// reading an object in an unstable intermediate state.

class Watcher extends Thread {
        AlwaysEven ae;
        public Watcher(AlwaysEven x) {
                ae = x; start();
        }
        public void run() {
                while(true) {
                        int val = ae.getValue();
                        if(val % 2 != 0) {
                                System.out.println(val);
                                System.exit(0);
                        }
                }
        }
}

public class AlwaysEven {
          private int i = 0;
          public synchronized void next() { i++;  i++; }
          public int getValue() {  
        	  synchronized(this)
        	  	return i; 
          }

          public static void main(String[] args) {
                    final AlwaysEven ae = new AlwaysEven();
                    new Watcher(ae);
                    while(true)
                               ae.next();
          }
} ///:~


